Index: /trunk/src/sys/arch/mips/mips/mips_machdep.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/mips_machdep.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/mips_machdep.c	(revision 152)
@@ -1256,9 +1645,8 @@
 	tf->tf_regs[_R_A1] = 0;
 	tf->tf_regs[_R_A2] = 0;
-	tf->tf_regs[_R_A3] = (intptr_t)l->l_proc->p_psstr;
-
-	if (l->l_md.md_flags & MDP_FPUSED)
-		fpudiscard_lwp(l);
-	memset(&l->l_addr->u_pcb.pcb_fpregs, 0, sizeof(struct fpreg));
+	tf->tf_regs[_R_A3] = (intptr_t)p->p_psstr;
+
+	fpu_discard();
+	memset(&pcb->pcb_fpregs, 0, sizeof(struct fpreg));
 	l->l_md.md_flags &= ~MDP_FPUSED;
 	l->l_md.md_ss_addr = 0;
@@ -1334,5 +1722,5 @@
 
 #if 0
-struct user dumppcb;		/* Actually, struct pcb would do. */
+struct pcb dumppcb;
 #endif
 
@@ -1604,7 +1992,7 @@
 	vsize_t sz = (vsize_t)round_page(MSGBUFSIZE);
 	vsize_t reqsz = sz;
-	struct vm_physseg *vps;
-
-	vps = &vm_physmem[vm_nphysseg - 1];
+	u_int bank = vm_nphysseg - 1;
+	struct vm_physseg *vps = VM_PHYSMEM_PTR(bank);
+
 #ifndef _LP64
 	/*
@@ -1632,7 +2020,7 @@
 	/* Remove the [last] segment if it now has no pages. */
 	if (vps->start == vps->end) {
-		for (; vps != &vm_physmem[vm_nphysseg - 1]; vps++)
-			vps[0] = vps[1];
-		vm_nphysseg--;
+		for (vm_nphysseg--; bank < vm_nphysseg - 1; bank++) {
+			VM_PHYSMEM_PTR_SWAP(bank, bank + 1);
+		}
 	}
 
@@ -1646,7 +2034,7 @@
 mips_init_lwp0_uarea(void)
 {
-	struct lwp *l = curlwp;
+	struct lwp * const l = &lwp0;
 	vaddr_t v;
-	KASSERT(l == &lwp0);
+
 	if (l->l_addr == NULL) {
 		v = uvm_pageboot_alloc(USPACE);
@@ -1656,10 +2044,18 @@
 		proc0paddr = l->l_addr;
 	}
-	lwp0.l_md.md_utf = (struct trapframe *)(v + USPACE) - 1;
+
+	l->l_md.md_utf = (struct trapframe *)(v + USPACE) - 1;
+	struct pcb * const pcb = lwp_getpcb(l);
+	/*
+	 * Now zero out the only two areas of the uarea that we care about.
+	 */
+	memset(l->l_md.md_utf, 0, sizeof(*l->l_md.md_utf));
+	memset(pcb, 0, sizeof(*pcb));
+
+	pcb->pcb_context.val[_L_SR] = MIPS_SR_INT_IE
+	    | (ipl_sr_map.sr_bits[IPL_SCHED] ^ MIPS_INT_MASK);
 #ifdef _LP64
-	lwp0.l_md.md_utf->tf_regs[_R_SR] = MIPS_SR_KX;
-	lwp0.l_addr->u_pcb.pcb_context.val[_L_SR] = MIPS_SR_KX | MIPS_SR_INT_IE;
-#else
-	lwp0.l_addr->u_pcb.pcb_context.val[_L_SR] = MIPS_SR_INT_IE;
+	pcb->pcb_context.val[_L_SR] |= MIPS_SR_KX | MIPS_SR_UX;
+	l->l_md.md_utf->tf_regs[_R_SR] = MIPS_SR_KX | MIPS_SR_UX;
 #endif
 }
@@ -1830,16 +2226,13 @@
 startlwp(void *arg)
 {
-	ucontext_t *uc = arg;
-	int err;
-
-	err = cpu_setmcontext(curlwp, &uc->uc_mcontext, uc->uc_flags);
-#if DIAGNOSTIC
-	if (err) {
-		printf("%s: Error %d from cpu_setmcontext", __func__, err);
-	}
-#endif
+	ucontext_t * const uc = arg;
+	lwp_t * const l = curlwp;
+	int error;
+
+	error = cpu_setmcontext(l, &uc->uc_mcontext, uc->uc_flags);
+	KASSERT(error == 0);
+
 	pool_put(&lwp_uc_pool, uc);
-
-	userret(curlwp);
+	userret(l);
 }
 
@@ -1851,16 +2244,14 @@
 startlwp32(void *arg)
 {
-	ucontext32_t *uc = arg;
-	int err;
-
-	err = cpu_setmcontext32(curlwp, &uc->uc_mcontext, uc->uc_flags);
-#if DIAGNOSTIC
-	if (err) {
-		printf("%s: Error %d from cpu_setmcontext32", __func__, err);
-	}
-#endif
+	ucontext32_t * const uc = arg;
+	lwp_t * const l = curlwp;
+	int error;
+
+	error = cpu_setmcontext32(l, &uc->uc_mcontext, uc->uc_flags);
+	KASSERT(error == 0);
+
+	/* Note: we are freeing ucontext_t, not ucontext32_t. */
 	pool_put(&lwp_uc_pool, uc);
-
-	userret(curlwp);
+	userret(l);
 }
 #endif /* COMPAT_NETBSD32 */
@@ -1966,2 +2357,13 @@
 }
 #endif /* PARANOIA */
+
+#if (MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
+static void
+mips_watchpoint_init(void)
+{
+	/*
+	 * determine number of CPU watchpoints
+	 */
+	curcpu()->ci_cpuwatch_count = cpuwatch_discover();
+}
+#endif
Index: /trunk/src/sys/arch/mips/mips/mips_mcclock.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/mips_mcclock.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/mips_mcclock.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: mips_mcclock.c,v 1.16.28.1 2010/01/20 09:04:35 matt Exp $ */
+/* $NetBSD: mips_mcclock.c,v 1.16.28.2 2011/04/29 08:26:29 matt Exp $ */
 
 /*
@@ -35,5 +35,5 @@
 #include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
 
-__KERNEL_RCSID(0, "$NetBSD: mips_mcclock.c,v 1.16.28.1 2010/01/20 09:04:35 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: mips_mcclock.c,v 1.16.28.2 2011/04/29 08:26:29 matt Exp $");
 
 #include <sys/param.h>
@@ -61,7 +61,5 @@
  */
 unsigned
-mc_cpuspeed(mcclock_addr, cpuintmask)
-	vaddr_t mcclock_addr;
-    	int cpuintmask;
+mc_cpuspeed(vaddr_t mcclock_addr, int cpuintmask)
 {
 	return mips_mc_cpuspeed((void *)mcclock_addr, cpuintmask,
@@ -80,8 +78,5 @@
  */
 unsigned
-mips_mc_cpuspeed(mcclock_addr, clockmask, tickpollfn)
-	void *mcclock_addr;
-	int clockmask;
-	int (*tickpollfn)(void *mcclock_addr, int clockmask);
+mips_mc_cpuspeed(void *mcclock_addr, int clockmask, int (*tickpollfn)(void *mcclock_addr, int clockmask))
 {
 	int s;
@@ -144,7 +139,5 @@
 
 int
-mips_mcclock_tickloop(mcclock_addr, clockmask)
-	void *mcclock_addr;
-	int clockmask;
+mips_mcclock_tickloop(void *mcclock_addr, int clockmask)
 {
 	int iters;
Index: /trunk/src/sys/arch/mips/mips/mips_mcclock_loop.S
===================================================================
--- /trunk/src/sys/arch/mips/mips/mips_mcclock_loop.S	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/mips_mcclock_loop.S	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: mips_mcclock_loop.S,v 1.3.18.1 2009/08/21 17:50:35 matt Exp $ */
+/* $NetBSD: mips_mcclock_loop.S,v 1.3.18.2 2011/04/29 08:26:29 matt Exp $ */
 
 /*
@@ -65,5 +65,5 @@
 	 move		v0, s0			# return iters
 	REG_L		ra, CALLFRAME_RA(sp)
-	REG_S		s0, CALLFRAME_S0(sp)
+	REG_L		s0, CALLFRAME_S0(sp)
 	j		ra
 	 PTR_ADDU	sp, CALLFRAME_SIZ
Index: /trunk/src/sys/arch/mips/mips/mips_softint.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/mips_softint.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/mips_softint.c	(revision 152)
@@ -28,12 +28,11 @@
  */
 
-#include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
-
-__KERNEL_RCSID(0, "$NetBSD: mips_softint.c,v 1.1.2.6 2010/02/22 20:17:09 matt Exp $");
+#include <sys/cdefs.h>
+__KERNEL_RCSID(0, "$NetBSD: mips_softint.c,v 1.1.2.8 2011/04/29 08:26:29 matt Exp $");
 
 #include <sys/param.h>
+#include <sys/cpu.h>
 #include <sys/proc.h>
 #include <sys/lwp.h>
-#include <sys/user.h>
 #include <sys/intr.h>
 #include <sys/atomic.h>
@@ -105,5 +104,5 @@
 		    IPL_SOFT##level); \
 		KASSERT(ci->ci_softlwps[SOFTINT_##level]->l_ctxswtch == 0); \
-		KASSERTMSG(ci->ci_cpl != IPL_HIGH, ("cpl (%d) != HIGH", ci->ci_cpl)); \
+		KASSERTMSG(ci->ci_cpl == IPL_HIGH, ("cpl (%d) != HIGH", ci->ci_cpl)); \
 		continue; \
 	}
@@ -118,5 +117,7 @@
 	KASSERT((ipending & ~MIPS_SOFT_INT_MASK) == 0);
 	KASSERT(ci->ci_cpl == IPL_HIGH);
-	KASSERT(ci->ci_mtx_count == 0);
+	KASSERTMSG(ci->ci_mtx_count == 0,
+	    ("%s: cpu%u (%p): ci_mtx_count (%d) != 0",
+	     __func__, cpu_index(ci), ci, ci->ci_mtx_count));
 
 	if (ipending & MIPS_SOFT_INT_MASK_0) {
Index: /trunk/src/sys/arch/mips/mips/netbsd32_machdep.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/netbsd32_machdep.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/netbsd32_machdep.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: netbsd32_machdep.c,v 1.1.2.5 2010/04/30 16:11:53 matt Exp $	*/
+/*	$NetBSD: netbsd32_machdep.c,v 1.1.2.6 2011/04/29 08:26:29 matt Exp $	*/
 
 /*-
@@ -31,5 +31,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: netbsd32_machdep.c,v 1.1.2.5 2010/04/30 16:11:53 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: netbsd32_machdep.c,v 1.1.2.6 2011/04/29 08:26:29 matt Exp $");
 
 #include "opt_compat_netbsd.h"
@@ -41,4 +41,5 @@
 #include <sys/ioctl.h>
 #include <sys/exec.h>
+#include <sys/cpu.h>
 #include <sys/core.h>
 #include <sys/file.h>
@@ -51,5 +52,4 @@
 #include <sys/signalvar.h>
 #include <sys/mount.h>
-#include <sys/user.h>
 #include <sys/syscallargs.h>
 
@@ -58,5 +58,4 @@
 #include <compat/netbsd32/netbsd32_syscallargs.h>
 
-#include <mips/cpu.h>
 #include <mips/cache.h>
 #include <mips/sysarch.h>
@@ -65,10 +64,10 @@
 #include <mips/frame.h>
 #include <mips/regnum.h>
-#include <mips/reg.h>
+#include <mips/pcb.h>
 
 #include <uvm/uvm_extern.h>
 
-char machine32[] = MACHINE;
-char machine_arch32[] = MACHINE32_ARCH;
+const char machine32[] = MACHINE;
+const char machine_arch32[] = MACHINE32_ARCH;
 
 #if 0
@@ -264,4 +263,6 @@
 		memcpy(&mco32->__fpregs, &mc.__fpregs,
 		    sizeof(struct fpreg_oabi));
+	mco32->_mc_tlsbase = mc._mc_tlsbase;
+	*flagsp |= _UC_TLSBASE;
 }
 
@@ -281,4 +282,5 @@
 		memcpy(&mc.__fpregs, &mco32->__fpregs,
 		    sizeof(struct fpreg_oabi));
+	mc._mc_tlsbase = mco32->_mc_tlsbase;
 	return cpu_setmcontext(l, &mc, flags);
 }
@@ -307,9 +309,9 @@
 	}
 
-	if (l->l_md.md_flags & MDP_FPUSED)
-		fpusave_lwp(l);
-
+	fpu_save_lwp(l);
+
+	struct pcb * const pcb = lwp_getpcb(l);
 	cpustate.frame = *l->l_md.md_utf;
-	cpustate.fpregs = l->l_addr->u_pcb.pcb_fpregs;
+	cpustate.fpregs = pcb->pcb_fpregs;
 
 	CORE_SETMAGIC(cseg, CORESEGMAGIC, MID_MACHINE, CORE_CPU);
